; INSTR replacement string searcher routines test

TimesToLoop equ 10

; procs to test
Procs textequ <OVH,InStrL,finstr,finstr2,finstr3,finstr4,finstr5,finstr6>	; include OVH to check that overhead is being properly removed from timing
;Procs textequ <InStrL,finstr>

; strings to test.  Source/Pattern, Source2/Pattern2, etc.
Tests TEXTEQU <Mainstr/Substr1,Mainstr/Substr2, Mainstr/Substr3, Mainstr/Substr4, mismatch/mmword>
TestType Textequ <Short,Medium,Long,HighAnsi,MisMatch>
PriClass textequ <REALTIME_PRIORITY_CLASS> ; priority to use for tests
;PriClass textequ <NORMAL_PRIORITY_CLASS>	; for debugging
    
.686p
.model	flat, stdcall
option	casemap :none   ; case sensitive
.nolist
include windows.inc
uselib	MACRO	libname
	include		libname.inc
	includelib	libname.lib
ENDM
uselib user32
uselib kernel32
uselib comctl32
uselib gdi32
uselib shell32
uselib comdlg32
uselib masm32
uselib debug
include macros.asm

inv equ Invoke

soff Macro QuotedText:Vararg	; returns offset to a string
Local LocalText
.data
LocalText db QuotedText,0
.code
EXITM <offset LocalText>
Endm
.listall

.data?
align 16
StartingCycle dd ?
CyclePart2	  dd ?
Loops         dd ?
ExtraLoops    dd ?
Min           dd ?
OverHead      dd ?   ; overhead of doing an empty proc
.code
BeginCounter macro	; This macro is inserted before a block of test code
	align 16	; just to be sure all code starts with equal advantage
    invoke GetCurrentProcess
    invoke SetPriorityClass, eax, PriClass	; use the highest priority for all the tests
	invoke GetCurrentThread
	inv SetThreadPriority,eax,THREAD_PRIORITY_TIME_CRITICAL
            
	mov Min,9999999999
	mov Loops,TimesToLoop
	mov ExtraLoops,10	; will do several times first to let things settle out
    inv Sleep,0
ExtraLoopsLoop = $
	sub ExtraLoops,1
TimingLoop = $
	mov	[StartingCycle],eax		; just to make sure they are in the cache
	mov	[StartingCycle+4],eax
	Repeat 6	; Intel says 4 but I've found that more works a little better
	xor eax,eax
	cpuid 		; call the EAX=0 version of CPUID to clear pipeline (serialize) (finish any pending instructions)
	Endm
	rdtsc
	mov	[StartingCycle],eax
	mov	[StartingCycle+4],edx
endm
EndCounter macro		; This macro is inserted after each block of test code
	xor eax,eax
	cpuid		; flush
	rdtsc
	cmp ExtraLoops,0
	jne ExtraLoopsLoop	; skip first several iterations
	sub eax,[StartingCycle]	; get result in EDX:EAX
	sbb edx,[StartingCycle+4]
	cmp Min,eax
	jb @f
	mov Min,eax
@@:
	sub Loops,1
	jnz TimingLoop
	invoke GetCurrentThread
	inv SetThreadPriority,eax,THREAD_PRIORITY_NORMAL
    invoke GetCurrentProcess
    invoke SetPriorityClass, eax, NORMAL_PRIORITY_CLASS	; back to normal
    inv Sleep,0 
	mov eax,Min		; return the minimum elapsed time
	.if DoingOverhead==0
		sub eax,OverHead
	.endif
endm
;----------------------------  SETUP --------------------------------------
.data			; data for tests
    align 16
    Mainstr db "The time has come the walrus said to speak of many things,"
            db " of birds and bugs and ceiling wax, of cabbages and kings."
            db " And if the sea is boiling hot and whether pigs have wings  ",0

    Substr1  db " walrus ",0

    Substr2  db "ceiling wax",0

    Substr3  db "sea is boiling hot",0

    Substr4  db "",0
align 4
    mismatch db "billabone billabone billabone billabone billabone billabone billabone billabone billabone billabone "
             db "billabone billabone billabone billabone billabone billabone billabone billabone billabone billabone "
             db "billabone billabone billabone billabone billabone billabone billabone billabone billabong ",0

align 4
    mmword   db "billabong",0

    cl1 dd 0
    cl2 dd 0
    cl3 dd 0

    .data?			; data for finstr routines
      align 16
      _ebx dd ?
      _esi dd ?
      _edi dd ?
      _ebp dd ?
      _esp dd ?

.code

    MAXWIDTH  equ 20
    HDRWIDTH  equ 7   ; leftmost header column
    COLWIDTH  equ 9

    %FOR proc,<Procs>	; ******  the calls to all procs must be the same for valid comparisons
        proc proto :dword,:dword ;,:dword,:dword,:dword,:dword,:dword
    ENDM

	MaxStr=0
	scount=0
	%For T1T2,<Tests>	; get maximum string size
		local T1,T2,sep
	    sep instr 1,<T1T2>,</>
	    T1 substr <T1T2>,1,sep-1    ; len of string 1
	    if sizeof T1 GT MaxStr
	    	MaxStr= sizeof T1
	    endif
	    T2 substr <T1T2>,sep+1      ; len of string 2
	    if sizeof T2 GT MaxStr
	    	MaxStr=sizeof T2
	    endif
	    scount=scount+2
	ENDM



.data
align 16
String1 db MaxStr*2+64 dup (0)      ; what will be input string1 to routines.  The extra 64 bytes are to represent
align 16                            ;   a possible next string in the real world that we would not want wiped out.
String2 db MaxStr+32   dup (0)      ; what will be input string2 to routines    

align 16
Str1Offset      dd  0   ; offset to starting byte within String1 based upon number of extra bytes being tested
Str2Offset      dd  0   ; offset to starting byte within String2 based upon number of extra bytes being tested
Junk		    dd  0   ; scrath place for mem protect	
.code
align 16

;Printing routines from Phil
sxFld proc DDpointer:DWORD, rvstring:DWORD, DDwidth:DWORD, DDalign:DWORD    
    .if DDalign == 0                    ; align left?
        invoke szLeft,DDpointer,rvstring,DDwidth
        invoke szLen,rvstring
        mov edx,rvstring
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+eax],32	;space
        inc eax
        jmp @B
    @@: mov byte ptr [edx+eax],0
    .elseif DDalign == 1                ; align right?
        invoke szLen,DDpointer
        mov edx,rvstring
        xor ecx,ecx
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+ecx],32
        inc eax
        inc ecx
        jmp @B
    @@: add edx,ecx
        invoke szLeft,DDpointer,edx,DDwidth
    .endif
    ret 4*4
sxFld endp

fld$ MACRO DDpointer,DDwidth,DDalign:=<0>       ; Default is align left
    LOCAL rvstring
    .data
        rvstring db MAXWIDTH+4 dup (0)
        align 16
    .code
    invoke sxFld,reparg(DDpointer),ADDR rvstring,DDwidth,DDalign
    EXITM <ADDR rvstring>
ENDM


;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------

.data
 DoingOverhead dd 0
.code

align 16

start:
	pcount=1
	%for proc,<Procs>	; count number of routines to test
		pcount=pcount+1
	endm
.data
	align 4
	ptable dd pcount dup (0)	; table of proc addresses
	lastproc dd 0				; address of last proc
	pname dd pcount dup (0)		; table of addresses of proc names for printing
.code
	mov edx,offset ptable	; address to call
	mov ecx,offset pname	; address of ascii name of routines for printing
	%for proc,<Procs>
		mov eax,offset proc
		mov [edx],eax		; save address of proc to call
		mov lastproc,edx	; save ending condition for loops
		add edx,4
		ifndef &proc&name
.data
			&proc&name db "&proc&",0	; save the proc names for headers
.code
		endif
		mov [ecx],offset &proc&name		; save the address of the proc name for headers
		add ecx,4
	endm

.data
	T1T2s dd scount dup (0)		; offsets of the test strings
	lastT1T2 dd 0  				; address of last T1T2 to use
.code
	mov edx,offset T1T2s
	%FOR T1T2,<Tests>
		local T1,T2,sep
	    sep instr 1,<T1T2>,</>
	    T1 substr <T1T2>,1,sep-1 	; Source
	    T2 substr <T1T2>,sep+1      ; Pattern
	    mov eax,offset T1
	    mov [edx],eax
	    mov eax,Offset T2
	    mov [edx+4],eax
	    mov lastT1T2,edx
	    add edx,8
	ENDM

	; Now move the actual code to test to a common postion so all tests have the same advantage
	mov ecx,MaximumProcSize
	mov edx,offset TheProc
    inv VirtualProtect,edx,ecx,PAGE_EXECUTE_READWRITE,addr Junk	; stupid invoke
    invoke GetCurrentProcess
    mov edx,MaximumProcSize
    mov ecx,offset TheProc
    invoke FlushInstructionCache,eax,ecx,edx	; ditto
 
;   print out the headers
	
    print fld$(chr$("Type"),HDRWIDTH)
    %FOR T1T2,<TestType>
        print fld$(chr$("&T1T2&"),COLWIDTH,1)
    ENDM
    print chr$(13,10)

    print fld$(chr$("Source"),HDRWIDTH)
    mov ebx,offset T1T2s
    %FOR T1T2,<Tests>
        local sep
        sep instr 1,<T1T2>,</>
        print fld$(left$(chr$("&T1T2&"),sep-1),COLWIDTH,1)
    ENDM
    print chr$(13,10)
    print fld$(chr$("Pattern"),HDRWIDTH)
    %FOR T1T2,<Tests>
        local T1,T2,sep
        sep instr 1,<T1T2>,</>
        T1 substr <T1T2>,1,sep-1    ; Source
        T2 substr <T1T2>,sep+1      ; Pattern
        print fld$( remove$( chr$("&T1T2&"),left$(chr$("&T1T2&"),sep)),COLWIDTH,1)
    ENDM
    print chr$(13,10)

    print fld$(chr$("====================="),HDRWIDTH)
    %FOR T1T2,<Tests>
        print fld$(" =====================",COLWIDTH)
    ENDM
    print chr$(13,10)


.data?
	PAddr      dd ?	; address of proc to call
	PTblPtr    dd ?	; address of proc within table
	PNamePtr   dd ? ; address of proc name within table
	TPtr       dd ?	; address of offset to test strings in table T1T2s
	T1Offset   dd ? ; offset of string 1 (string to search)
	T2Offset   dd ? ; offset of string 2 (patter to search for)
.code	
        ;%FOR proc,<Procs>
        mov PTblPtr,offset ptable	; initialize loop
        mov PNamePtr,offset pname
        procsloop:
            mov eax,PTblPtr	; get address of routine to test
            mov eax,[eax]
            mov PAddr,eax
            mov eax,PNamePtr
            mov eax,[eax]
            mov ecx,[eax]
            cmp ecx,0048564fh	; "OVH"  check for overhead proc
	        jne @f
	        mov DoingOverhead,1
	@@:
            print fld$(eax,HDRWIDTH)
            ; now move the proc to a standard location
           mov esi,PAddr
           mov ecx,MaximumProcSize
           mov edi,offset TheProc
           rep movsb
           cpuid
;           %FOR T1T2,<Tests>
          	mov TPtr,offset T1T2s	; initialize loop
          	T1T2loop: 
                mov ecx,TPtr				; get offset of string 1
                mov eax,[ecx]
                mov T1Offset,eax
                mov eax,[ecx+4]				; get length of string 2
                mov T2Offset,eax

                BeginCounter
                push T2Offset
                push T1Offset
                call TheProc
                EndCounter
                cmp DoingOverhead,1
                jne @f
                mov OverHead,eax
                mov DoingOverhead,0
@@:
                mov ebx,eax
                print fld$(sstr$(ebx),COLWIDTH,1)
                
            ;ENDM
            add TPtr,8
            mov eax,TPtr
            cmp eax,lastT1T2
            jbe T1T2loop
            print chr$(13,10)

        add PNamePtr,4
        add PTblPtr,4
        mov eax,PTblPtr
        cmp eax,lastproc
        jbe procsloop        

QuitTests:
    mov   eax,input(13,10,"Press enter to exit...")
    exit


;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
; --------------------- Routines under test ---------------------------------------------
;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------


;--------  All routines must be written with the same call to be fairly compared  ------- 


ProcMaxSize=0
;---------------All routines must be surrounded by this code-----------------------------
align 16
PStart = $
; --------------  Routine goes here --------------------------------------

ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif

;************************  for these tests, all routines will be prologue:none,etc.
OPTION PROLOGUE:NONE			; turn it off (for all routines being tested)
OPTION EPILOGUE:NONE			;

;---------------------------- Routine 1 ----------------------------------
align 16
PStart = $
; --------------  Routine goes here --------------------------------------
align 16						;
InStrL	proc lpSource:DWORD, lpPattern:DWORD
	mov		eax, [esp+1*4]		; eax-> lpSource
    mov		edx, [esp+2*4]		; edx->lpPattern
    movzx	ecx, byte ptr [edx] ; ecx->the 1st byte of substring
	mov		[esp+2*4], esi		; saving register esi
    imul	ecx, 1010101h       ; ecx=77 77 77 77h  ; 77h -> ASCII code of "w"
	mov		[esp+1*4], ebx		; saving register ebx
	lea		esi, [edx+1]		; esi->lp Pattern +1
BytesScan:						;
	mov		edx, ecx			; edx=77 77 77 77h  ; 77h -> ASCII code of "w"
	xor		ebx, ebx			;
@@:								;
	xor		ecx, [eax]			;
	add		eax, 4				;              
	add		ecx, 0FEFEFEFFh		;   
    test	ecx, 080808080h		;   
	mov		ecx, edx			; edx=77 77 77 77h  ; 77h -> ASCII code of "w"
  	je		@b					; 
								;
    cmp		[eax-4], dl			; dl ->1st byte of pattern
    lea		eax, [eax-3]	
	je		@f
    cmp		[eax], dl			; dl ->1st byte of pattern
    lea		eax, [eax+1]	
	je		@f
    cmp		[eax], dl			; dl ->1st byte of pattern
    lea		eax, [eax+1]
	je		@f
    cmp		[eax], dl			; dl ->1st byte of pattern
    lea		eax, [eax+1]
	jne		@b
@@:								; CMP rest  of strings
	add		bl,	 [esi]
	je		@found	
	sub		bl,	 [eax]
	jne		BytesScan
	add		bl,	 [esi+1]
	je		@found	
	sub		bl,	 [eax+1]
	jne		BytesScan
	add		bl,	 [esi+2]
	je		@found	
	sub		bl,	 [eax+2]
	jne		BytesScan
	add		bl,	 [esi+3]
	je		@found	
	sub		bl,	 [eax+3]
	jne		BytesScan	
	add		bl,	 [esi+4]
	je		@found	
	sub		bl,	 [eax+4]
	jne		BytesScan
	add		bl,	 [esi+5]
	je		@found	
	sub		bl,	 [eax+5]
	jne		BytesScan
	add		bl,	 [esi+6]
	je		@found	
	sub		bl,	 [eax+6]
	jne		BytesScan
	add		bl,	 [esi+7]
	je		@found	
	sub		bl,	 [eax+7]
	jne		BytesScan
	add		bl,	 [esi+8]
	je		@found	
	sub		bl,	 [eax+8]
	jne		BytesScan
	mov		edx, 8
@@:	
	add		bl,	 [esi+edx+1]
	je		@found	
	sub		bl,	 [eax+edx+1]
	jne		BytesScan
	add		bl,	 [esi+edx+2]
	je		@found	
	sub		bl,	 [eax+edx+2]
	jne		BytesScan
	add		bl,	 [esi+edx+3]
	je		@found	
	sub		bl,	 [eax+edx+3]
	jne		BytesScan
	add		bl,	 [esi+edx+4]
	je		@found	
	sub		bl,	 [eax+edx+4]
	jne		BytesScan
	add		edx, 4
	jne		@b
@found:	
	mov		ebx, [esp+1*4]	 
	cmp		eax, esi		
	mov		esi, [esp+2*4]	 
	sbb		ecx, ecx
	mov		edx, [esp]	 
	add		eax,  -1		
	add		esp, 3*4 
	and		eax, ecx		;eax-> address of 1st occurrence or 0->Not found   
	jmp		edx				;
InStrL	endp			;


ProcSize = $ - PStart
if ProcSize GT ProcMaxSize
   ProcMaxSize=ProcSize
endif

;---------------------------- Routine 2 ----------------------------------

PStart = $
; --------------  Routine goes here --------------------------------------
align 16
;********************  note  ************************
;   This is Hutch's routine with the first parameter removed so
;    that the call is identical to Lingo's routine for testing
;    the return was also made identical for timing test purposes.
finstr proc psrc:DWORD,patn:DWORD

  ; --------------------------
  ; simplified faster InString algorithm.
  ; --------------------------
  ; arguments
  ; ---------
  ; ***** 1 spos = 1 based index start offset in source address *** removed
  ; 2 psrc = the source address to be searched
  ; 3 patn = the address of the pattern to be searched for
  ; --------------------------
  ; return values
  ; -------------
  ; on match, 1 based index offset from start of source.  **** changes to match Lingo
  ; no match returns zero.
  ; --------------------------
  ; NOTE: The "spos" can be set past the end of the
  ; source buffer which will generate an unhandled
  ; exception. To address this potential problem with
  ; sequential searches, the return value should be
  ; incremented by ONE BYTE at a time which ensures
  ; that the starting position "spos" never goes past
  ; the end of the source buffer.
  ; --------------------------

    mov _ebx, ebx
    nop
    nop
    mov _esi, esi
    nop
    nop
    mov _edi, edi
    nop
    nop
    mov _ebp, ebp
    nop
    nop
    mov _esp, esp

    nop
    nop
    mov edi, [esp+8]               ; patn
    movzx eax, BYTE PTR [edi]       ; set 1st patn byte in AL
    mov esi, [esp+4]                ; psrc
    ;;; add esi, [esp+4]                ; spos
    sub esi, 4                      ; correct for 1 to 0 based index
                                    ; and dec by 1 for following loop
    mov esp, 80808080h
    mov ebp, 1

; --------------------

  scanloop:
  REPEAT 16
  ; ----------------------------------------------
  ; test if the next 4 bytes contain an ascii zero
  ; ----------------------------------------------
    add esi, 4
    mov edx, [esi]
    lea ecx, [edx-01010101h]
    not edx
    and ecx, esp        ; modify ECX
    test ecx, edx       ; test with no modify
    jnz no_match
  ; ----------------------------------------
  ; test each byte for a patn 1st char match
  ; ----------------------------------------
    movzx ebx, BYTE PTR [esi]
    sub ebx, eax
    jz si0
    movzx ecx, BYTE PTR [esi+1]
    sub ecx, eax
    jz si1
    movzx edx, BYTE PTR [esi+2]
    sub edx, eax
    jz si2
    movzx ecx, BYTE PTR [esi+3]
    sub ecx, eax
    jz si3
  ENDM
    jmp scanloop

; --------------------

  si3:
    add esi, ebp
  si2:
    add esi, ebp
  si1:
    add esi, ebp
  si0:                              ; set index
    xor ebx, ebx

; --------------------

  matchloop:
  REPEAT 8
    add ebx, ebp
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match                        ; text match if patn terminator found
    movzx ecx, BYTE PTR [esi+ebx]
    cmp ecx, edx                    ; test for match
    jne scanloop

    add ebx, ebp
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match                        ; text match if patn terminator found
    movzx ecx, BYTE PTR [esi+ebx]
    cmp ecx, edx                    ; test for match
    jne scanloop

  ENDM
    jmp matchloop

; --------------------

  match:
    mov esp, _esp
    ;sub esi, [esp+4]                ; psrc
    ; lea eax, [esi+1]
    mov eax, esi
    jmp cleanup

  no_match:
    mov esp, _esp
    xor eax, eax

  cleanup:
    mov ebx, _ebx
    mov esi, _esi
    mov edi, _edi
    mov ebp, _ebp

    ret 8
finstr endp

ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif

;---------------------------- Routine 3 ----------------------------------
align 16
PStart = $
; --------------  Routine goes here --------------------------------------
align 16
finstr2 proc psrc:DWORD,patn:DWORD
    mov _ebx, ebx
    mov _esi, esi
    mov _edi, edi
    mov _ebp, ebp
    mov _esp, esp

    mov edi, [esp+8]               ; patn
    movzx eax, BYTE PTR [edi]       ; set 1st pattern byte in AL
    mov esi, [esp+4]                ; psrc
    sub esi, 4 
    mov esp, 80808080h
    mov ebp, 1
	imul eax,01010101h				; get first byte in each byte of eax

  scanloop:
  REPEAT 16

    add esi, 4  	; test if the next 4 bytes contain an ascii zero
    mov edx, [esi]				;
    mov ebx,edx 	;save
    lea ecx, [edx-01010101h]    ;  
    not edx						; 
    and ecx, esp  ; modify ECX	; 
    test ecx, edx ; test with no modify
    jnz no_match

	;mov ebx,[esi]  ; test each byte for a pattern 1st char match
	xor ebx,eax		; turn any matching byte into a zero, else non-zero
	lea ecx,[ebx-01010101h]
	not ebx
	and ecx,esp
	and ecx,ebx
	jnz	foundone
endm
	jmp scanloop	

foundone:
    test cl,cl	; the first non-zero byte is the matching one
    jnz si0
    test ch,ch
    jnz si1
    shr ecx,8
    test ch,ch
    ;test ecx,00800000h
    jnz si2
    ; ----- else, must have been last byte, fall through to si3

  si3:
    add esi, ebp
  si2:
    add esi, ebp
  si1:
    add esi, ebp
  si0:                              ; set index
    xor ebx, ebx

; --------------------

  matchloop:
  REPEAT 16
    add ebx, ebp
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match                        ; text match if patn terminator found
    movzx ecx, BYTE PTR [esi+ebx]
    cmp ecx, edx                    ; test for match
    jne scanloop

  ENDM
    jmp matchloop

; --------------------

  match:
    mov esp, _esp
    ;sub esi, [esp+4]                ; psrc
    ; lea eax, [esi+1]
    mov eax, esi
    jmp cleanup

  no_match:
    mov esp, _esp
    xor eax, eax

  cleanup:
    mov ebx, _ebx
    mov esi, _esi
    mov edi, _edi
    mov ebp, _ebp

    ret 8
finstr2 endp


ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif

;---------------------------- Routine 4 ----------------------------------
align 16
PStart = $
; --------------  Routine goes here --------------------------------------
finstr3 proc psrc:DWORD,patn:DWORD
    mov _ebx, ebx
    mov _esi, esi
    mov _edi, edi
    mov _ebp, ebp
    mov _esp, esp

    mov edi, [esp+8]               ; patn
    movzx eax, BYTE PTR [edi]       ; set 1st pattern byte in AL
    mov esi, [esp+4]                ; psrc
    sub esi, 4                      ; correct for 1 to 0 based index
                                    ; and dec by 1 for following loop
    mov esp, 80808080h
    mov ebp, 1
	imul eax,01010101h				; get first byte in each byte of eax

  scanloop:
  REPEAT 16

    add esi, 4  	; test if the next 4 bytes contain an ascii zero
    mov edx, [esi]				; 
    lea ecx, [edx-01010101h]    ;  
    not edx						; 
    and ecx, esp  ; modify ECX	; 
    test ecx, edx ; test with no modify
    jnz no_match

	mov edx,[esi]  ; test each byte for a pattern 1st char match
	xor edx,eax
	lea ecx,[edx-01010101h]
	not edx
	and ecx,esp
	and ecx,edx
	jnz	foundone
endm
	jmp scanloop	

foundone:

    or cl,cl
    jnz si0
    add esi,ebp
    or ch,ch
    jnz si0
    add esi,ebp
    and ecx,00800000h
    jnz si0
    ; ----- else, must have been last byte, fall through to si3

    add esi, ebp
  si0:                              ; set index
    xor ebx, ebx

; --------------------

  matchloop:
  REPEAT 8
    add ebx, ebp
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match                        ; text match if patn terminator found
    movzx ecx, BYTE PTR [esi+ebx]
    cmp ecx, edx                    ; test for match
    jne scanloop

    add ebx, ebp
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match                        ; text match if patn terminator found
    movzx ecx, BYTE PTR [esi+ebx]
    cmp ecx, edx                    ; test for match
    jne scanloop

  ENDM
    jmp matchloop

; --------------------

  match:
    mov esp, _esp
    ;sub esi, [esp+4]                ; psrc
    ; lea eax, [esi+1]
    mov eax, esi
    jmp cleanup

  no_match:
    mov esp, _esp
    xor eax, eax

  cleanup:
    mov ebx, _ebx
    mov esi, _esi
    mov edi, _edi
    mov ebp, _ebp

    ret 8
finstr3 endp

ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif


;---------------------------- Routine 5 ----------------------------------
align 16
PStart = $
; --------------  Routine goes here --------------------------------------
finstr4 proc psrc:DWORD,patn:DWORD
    mov _ebx, ebx
    mov _esi, esi
    mov _edi, edi
    mov _ebp, ebp
    mov _esp, esp

    mov edi, [esp+8]               ; patn
    movzx eax, BYTE PTR [edi]       ; set 1st patn byte in AL
    mov esi, [esp+4]                ; psrc
    sub esi, 4                      ; correct for 1 to 0 based index
                                    ; and dec by 1 for following loop
    mov esp, 80808080h
    mov ebp, 1
  scanloop:
  REPEAT 16
    add esi, 4
	movzx ebx, BYTE PTR [esi]
	test ebx,ebx	
	jz no_match
	sub ebx, eax
    jz si0
    movzx ecx, BYTE PTR [esi+1]
    test ecx,ecx
    jz no_match
    sub ecx, eax
    jz si1
    movzx edx, BYTE PTR [esi+2]
    test edx,edx
    jz no_match
    sub edx, eax
    jz si2
    movzx ecx, BYTE PTR [esi+3]
    test ecx,ecx
    jz no_match
    sub ecx, eax
    jz si3
  ENDM
    jmp scanloop

  si3:    add esi, ebp
  si2:    add esi, ebp
  si1:    add esi, ebp
  si0:    xor ebx, ebx

  matchloop:
  REPEAT 8
    add ebx, ebp
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match                        ; text match if patn terminator found
    movzx ecx, BYTE PTR [esi+ebx]
    cmp ecx, edx                    ; test for match
    jne scanloop

    add ebx, ebp
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match                        ; text match if patn terminator found
    movzx ecx, BYTE PTR [esi+ebx]
    cmp ecx, edx                    ; test for match
    jne scanloop

  ENDM
    jmp matchloop

; --------------------

  match:
    mov esp, _esp
    ;sub esi, [esp+4]                ; psrc
    ; lea eax, [esi+1]
    mov eax, esi
    jmp cleanup

  no_match:
    mov esp, _esp
    xor eax, eax

  cleanup:
    mov ebx, _ebx
    mov esi, _esi
    mov edi, _edi
    mov ebp, _ebp

    ret 8
finstr4 endp

ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif

;---------------------------- Routine 6 ----------------------------------
align 16
PStart = $
; --------------  Routine goes here --------------------------------------
finstr5 proc psrc:DWORD,patn:DWORD
    mov _ebx, ebx
    mov _esi, esi
    mov _edi, edi
    mov _ebp, ebp

    mov edi, [esp+8]               ; patn
    mov eax, [edi]       ; set 1st patn byte in AL
    mov esi, [esp+4]                ; psrc
    sub esi, 4                      ; correct for 1 to 0 based index
                                    ; and dec by 1 for following loop
    mov ebp, 1
  scanloop:
  REPEAT 16
    add esi, 4
    mov ebx, [esi]
	or  bl,bl	
	jz no_match
    cmp bl, al
    je si0
    or bh,bh
    jz no_match
    cmp bh, al
    je si1
    mov edx, [esi+2]
    or dl,dl
    jz no_match
    cmp dl, al
    je si2
    or dh,dh
  	jz no_match
    cmp dh,al
    je si3
  ENDM
    jmp scanloop

  si3:    add esi, ebp
  si2:    add esi, ebp
  si1:    add esi, ebp
  si0:    xor ebx, ebx

  matchloop:
  REPEAT 16
    add ebx, ebp
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match                        ; text match if patn terminator found
    movzx ecx, BYTE PTR [esi+ebx]
    cmp ecx, edx                    ; test for match
    jne scanloop

  ENDM
    jmp matchloop

; --------------------

  match:
    ;sub esi, [esp+4]                ; psrc
    mov eax, esi
    jmp cleanup

  no_match:
    xor eax, eax

  cleanup:
    mov ebx, _ebx
    mov esi, _esi
    mov edi, _edi
    mov ebp, _ebp

    ret 8

finstr5 endp

ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif

;---------------------------- Routine 7 ----------------------------------
align 16
PStart = $
; --------------  Routine goes here --------------------------------------
finstr6 proc psrc:DWORD,patn:DWORD
    mov _ebx, ebx
    mov _esi, esi
    mov _edi, edi
    mov _ebp, ebp
    mov _esp, esp

    mov edi, [esp+8]               ; patn
    movzx eax, BYTE PTR [edi]       ; set 1st pattern byte in AL
    mov esi, [esp+4]                ; psrc
    sub esi, 4                      ; correct for 1 to 0 based index
                                    ; and dec by 1 for following loop
    mov esp, 80808080h
    mov ebp, 1
	imul eax,01010101h				; get first byte in each byte of eax

  scanloop:
  REPEAT 16

    add esi, 4  	; test if the next 4 bytes contain an ascii zero
    mov edx, [esi]				;
    mov ebx,edx 	;save
    lea ecx, [edx-01010101h]    ;  
    not edx						; 
    and ecx, esp  ; modify ECX	; 
    test ecx, edx ; test with no modify
    jnz no_match

	;mov ebx,[esi]  ; test each byte for a pattern 1st char match
	xor ebx,eax		; turn any matching byte into a zero, else non-zero
	lea ecx,[ebx-01010101h]
	not ebx
	and ecx,esp
	and ecx,ebx
	jnz	foundone
endm
	jmp scanloop	

foundone:
    test cl,cl	; the first non-zero byte is the matching one
    jnz si0
    test ch,ch
    jnz si1
    shr ecx,8
    test ch,ch
    ;test ecx,00800000h
    jnz si2
    ; ----- else, must have been last byte, fall through to si3

  si3:
    add esi, ebp
  si2:
    add esi, ebp
  si1:
    add esi, ebp
  si0:                              ; set index
    xor ebx, ebx

; --------------------

  matchloop:
  REPEAT 16
    add ebx, ebp
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match                        ; text match if patn terminator found
    movzx ecx, BYTE PTR [esi+ebx]
    cmp ecx, edx                    ; test for match
    jne scanloop

  ENDM
    jmp matchloop

; --------------------

  match:
    mov esp, _esp
    ;sub esi, [esp+4]                ; psrc
    ; lea eax, [esi+1]
    mov eax, esi
    jmp cleanup

  no_match:
    mov esp, _esp
    xor eax, eax

  cleanup:
    mov ebx, _ebx
    mov esi, _esi
    mov edi, _edi
    mov ebp, _ebp

    ret 8
finstr6 endp

ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif

;---------------------------- Routine 8 ----------------------------------
align 16
PStart = $
; --------------  Routine goes here --------------------------------------

ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

;-------------------------------------------------------------------------------


;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
; --------------------- End of Routines under test --------------------------------------
;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------

align 16
PStart = $
OVH proc xstr1:dword, xstr2:dword
   ret 8
OVH EndP 
ProcSize=$-PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
.data
MaximumProcSize dd ProcMaxSize
.code


;--------------------------  procs will be moved to here for testing  ------------------------------------
align 16
TheProc:
db ProcMaxSize+16 dup (0)

;-------------------------------------------------------------------------------

end start
